Index: include/client.h
===================================================================
RCS file: /cvsroot/ircd-hybrid-6/include/client.h,v
retrieving revision 1.60
diff -c -r1.60 client.h
*** include/client.h	4 Dec 2001 06:40:30 -0000	1.60
--- include/client.h	11 Feb 2002 02:54:51 -0000
***************
*** 341,346 ****
--- 341,348 ----
  #define FLAGS_OPER         0x4000 /* Operator */
  #define FLAGS_LOCOP        0x8000 /* Local operator -- SRB */
  
+ #define FLAGS_UNIDLE	   0x20000 /* *whistles innocently* */
+ 
  /* *sigh* overflow flags */
  #define FLAGS2_RESTRICTED   0x0001      /* restricted client */
  #define FLAGS2_PING_TIMEOUT 0x0002
***************
*** 386,391 ****
--- 388,394 ----
  #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP)
  #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                        FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
+ 					  FLAGS_UNIDLE | \
                        FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
                        FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOP )
  
Index: src/parse.c
===================================================================
RCS file: /cvsroot/ircd-hybrid-6/src/parse.c,v
retrieving revision 1.47
diff -c -r1.47 parse.c
*** src/parse.c	30 Dec 2001 03:25:48 -0000	1.47
--- src/parse.c	11 Feb 2002 02:55:18 -0000
***************
*** 336,345 ****
     */
  
  #ifdef IDLE_FROM_MSG
!   if (IsRegisteredUser(cptr) && mptr->reset_idle)
      from->user->last = CurrentTime;
  #else
!   if (IsRegisteredUser(cptr) && !mptr->reset_idle)
      from->user->last = CurrentTime;
  #endif
    
--- 336,345 ----
     */
  
  #ifdef IDLE_FROM_MSG
!   if (IsRegisteredUser(cptr) && mptr->reset_idle && !(cptr->umodes & FLAGS_UNIDLE))
      from->user->last = CurrentTime;
  #else
!   if (IsRegisteredUser(cptr) && !mptr->reset_idle && !(cptr->umodes & FLAGS_UNIDLE))
      from->user->last = CurrentTime;
  #endif
    
Index: src/s_user.c
===================================================================
RCS file: /cvsroot/ircd-hybrid-6/src/s_user.c,v
retrieving revision 1.248
diff -c -r1.248 s_user.c
*** src/s_user.c	23 Jan 2002 18:39:08 -0000	1.248
--- src/s_user.c	11 Feb 2002 02:55:26 -0000
***************
*** 81,86 ****
--- 81,87 ----
    {FLAGS_FULL,  'f'},
    {FLAGS_INVISIBLE, 'i'},
    {FLAGS_SKILL, 'k'},
+   {FLAGS_UNIDLE, 'l'},
    {FLAGS_NCHANGE, 'n'},
    {FLAGS_OPER, 'o'},
    {FLAGS_LOCOP, 'O'},
***************
*** 141,147 ****
    FLAGS_INVISIBLE, /* i */
    0,            /* j */
    FLAGS_SKILL,  /* k */
!   0,            /* l */
    0,            /* m */
    FLAGS_NCHANGE, /* n */
    FLAGS_OPER,   /* o */
--- 142,148 ----
    FLAGS_INVISIBLE, /* i */
    0,            /* j */
    FLAGS_SKILL,  /* k */
!   FLAGS_UNIDLE, /* l */
    0,            /* m */
    FLAGS_NCHANGE, /* n */
    FLAGS_OPER,   /* o */
***************
*** 2098,2103 ****
--- 2099,2110 ----
              }
            break;
          }
+ 
+   if ((sptr->umodes & FLAGS_UNIDLE) && !IsAnOper(sptr))
+   {
+     sptr->umodes &= ~FLAGS_UNIDLE;
+ 	if (!(setflags & (FLAGS_OPER|FLAGS_LOCOP))) badflag = YES;
+   }
  
    if(badflag)
      sendto_one(sptr, form_str(ERR_UMODEUNKNOWNFLAG), me.name, parv[0]);
